/*

 #####  #     # #     #          #####                 
#     # ##    # #     #         #     #   ####    for  
#       # #   # #     #         #        #    #   PocketPC  
#  #### #  #  # #     #         #  ####  #    #   (Windows CE)    
#     # #   # # #     #         #     #  #    #   ---------     
#     # #    ## #     #         #     #  #    #   version     
 #####  #     #  #####           #####    ####    1.2.0     

(c) Ivan Davtchev, 2000 <davtchev@yahoo.com>
Last modified on 12/27/00
Based on code from:

                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
     modified/ported to the PocketPC/WinCE by Ivan Davtchev, 2000

*** IMPORTANT: ***

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           davtchev@yahoo.com
*/

#include "stdafx.h"
#include "Helloworld.h"
#include <commctrl.h>
//#include <sipapi.h>

#include "gnugo.h"
#include "patterns.h"

#define MAX_LOADSTRING 100
#define STATUS_LEN 45

// board/stones related
#define BOARD_SIZE 19
#define EMPTY 0
#define BLACK 2
#define WHITE 1
#define STONE_SIZE 10
#define CELL_SIZE 12
//#define STONE_SIZE 8
//#define CELL_SIZE 10

// board's screen boundaries
#define TOP_EDGE 12
#define BOTTOM_EDGE 220

// loses top and click off by 10 #define TOP_EDGE 2
//  ditto   #define BOTTOM_EDGE 210

#define LEFT_EDGE 12
#define RIGHT_EDGE 220
//#define BOTTOM_EDGE 196
//#define RIGHT_EDGE 196

// game states
#define PLAYING 1
#define END_GAME 0
#define REMOVE_DEAD 2
#define FILL_NEUTRAL 3

#define NODES BOARD_SIZE*BOARD_SIZE
#define ENDLIST 1000
#define QSIZE 150
#define GREY  3
#define MAXTRY 400
#define line(x) (abs(x - 9))
#define SHGetSubMenu(hWndMB,ID_MENU) (HMENU)SendMessage((hWndMB), SHCMBM_GETSUBMENU, (WPARAM)0, (LPARAM)ID_MENU);

// Global Variables:
HINSTANCE			hInst;					// The current instance
HWND				hwndCB;					// The command bar handle
HWND				hWnd;					// The main and only window
HDC					hdc;					// Current screen "device"

// Debug Mode Flags & Vars!
int		debug = 0;
TCHAR	szDebugText[30] = TEXT("");

// Man Li Variables
unsigned char	p[BOARD_SIZE][BOARD_SIZE];  /* go board */
unsigned char	l[BOARD_SIZE][BOARD_SIZE];  /* liberty of current color */
unsigned char	ma[BOARD_SIZE][BOARD_SIZE]; /* working matrix for marking */
unsigned char	ml[BOARD_SIZE][BOARD_SIZE]; /* working matrix for marking */
int		mymove, umove;        /* computer color, opponent color */
int		lib;                  /* current stone liberty */
int		play;                 /* game state */
int		pass;                 /* pass indicator */
int		mik, mjk;             /* location of computer stone captured */
int		uik, ujk;             /* location of opponent stone captured */
int		mk, uk;               /* no. of stones captured by computer and oppoent */
int		opn[9];               /* opening pattern flag */
int		que[QSIZE],color[BOARD_SIZE*BOARD_SIZE],listpt[BOARD_SIZE*BOARD_SIZE];
int		*pe, *pstart;
int		endq;
int		queinit;
int		size;
int		utot, mtot;		// totals at the end

// Ivan Davtchev Variables :)
int		next = 193; // random seed
int     half_stone, half_cell, cell_plus; // 0.5*STONE_SIZE, 0.5*CELL_SIZE, CELL_SIZE+1
TCHAR   szCurrentText[STATUS_LEN] = TEXT(""); // the current state info on the screen
//static	SHACTIVATEINFO s_sai;
int		human_color = BLACK;
int		cpu_color = WHITE;
int		fill_color = BLACK; // for scoring at the end
int		lastI, lastJ, lastX, lastY; // coords of last stone placed
TCHAR	szCPUCaptured[30] = TEXT("PC captured ");
TCHAR	szHumanCaptured[30] = TEXT("you captured ");
TCHAR	szPass[5] = TEXT("pass");
TCHAR	szFormatA[3] = TEXT("%s");
TCHAR	szFormatB[3] = TEXT("%d");
TCHAR	szFormatNorm[20] = TEXT("(%C-%d) %s%d; %s%d");
TCHAR	szFormatPass[20] = TEXT("(%s) %s%d, %s%d");
TCHAR	szRemove[45] = TEXT("Remove all dead stones; choose Edit>Pass");
TCHAR	szFill[45] = TEXT("Fill all neutral spaces; choose Edit>Pass");
TCHAR	szWelcome[40] = TEXT("Welcome to GNU Go for the PocketPC!");
TCHAR	szCongrats[10] = TEXT("Congrats!");
TCHAR	szIWin[10] = TEXT("I won!");
TCHAR	szYourScore[20] = TEXT("Your score: ");
TCHAR	szMyScore[20] = TEXT("My score: ");
HGDIOBJ	oldBrush, bbrush, wbrush, gbrush, cbrush; // various brushes used for drawing
HPEN	oldPen, redPen; // pens for drawing
COLORREF	rgbBoard = 0x0066CCFF; // color for board
COLORREF	rgbCrimson = 0x00010195; // color for last piece so far
HMENU	myMenu; // for graying out items etc

// Undo variables
// I am not sure if l[19][19] is not persistent and therefore should be copied
// May be good for future versions to adopt a struct to represent the game
unsigned char	copy[BOARD_SIZE][BOARD_SIZE];  // backup board for undo
int		copy_pass, copy_mk, copy_uk; // backup (for undo) variables
TCHAR	szCopyCurrentText[STATUS_LEN] = TEXT(""); // backup of current status string

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass	(HINSTANCE, LPTSTR);
BOOL				InitInstance	(HINSTANCE, int);
LRESULT CALLBACK	WndProc			(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About			(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	GameOverBox		(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	NewBox			(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	ExplainBox		(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	HelpBox			(HWND, UINT, WPARAM, LPARAM);
HWND				CreateRpCommandBar(HWND);

static int			fval(int newlib, int minlib);

int myrandom(int n) {
	// simple random number function
	next = next * 1103515245 + 12345;
	return (unsigned int)(next/65536) % n;
}

// transform from screen coordinates to board position
// 0,0 is valid origin in both
BOOL ScreenToBoard	(int x, // screen x
					 int y, // screen y
					 int *i, // board x
					 int *j) // board y
{
	// this is a bit hard-wired (assumes TOP_EDGE etc = CELL_SIZE)
	int rx, ry, dx, dy;
	if (x < 0 || y < 0) return FALSE;
	rx = x % CELL_SIZE; 
	ry = y % CELL_SIZE;
	dx = (x-rx)/CELL_SIZE;
	dy = (y-ry)/CELL_SIZE;
	if (dx == 0 && rx <= half_cell) return FALSE;
	if (dy == 0 && ry <= half_cell) return FALSE;
	if (dx == BOARD_SIZE && rx > half_cell) return FALSE;
	if (dy == BOARD_SIZE && ry > half_cell) return FALSE;
	if (dx > BOARD_SIZE) return FALSE;
	if (dy > BOARD_SIZE) return FALSE;
	// otherwise the coords are legal
	if (rx <= half_cell) dx--;
	if (ry <= half_cell) dy--;
	*i = dx;
	*j = dy;
	return TRUE;
}

BOOL ValidMove(int i, int j) { // check the validity of a move
	if (p[i][j] != EMPTY || suicide(i,j))
		return FALSE;
	return TRUE;
}

void ClearBoard(void) { // clean the board
	int i, j;
	// Init the board
	for (i = 0; i < BOARD_SIZE; i++) {
		for (j = 0; j < BOARD_SIZE; j++) {
			p[i][j] = EMPTY;
		}
	}
}

void BackupBoard(void) { // back up for undo
	int i, j;
	// copy the board
	for (i = 0; i < BOARD_SIZE; i++) {
		for (j = 0; j < BOARD_SIZE; j++) {
			copy[i][j] = p[i][j];
		}
	}
	copy_pass = pass;
	copy_mk = mk;
	copy_uk = uk;
	// copy status string
	for (i = 0; i < STATUS_LEN; i++) {
		szCopyCurrentText[i] = szCurrentText[i];
	}
	// enable (un-gray) the Undo command
	EnableMenuItem(myMenu, IDM_EDIT_UNDO, MF_ENABLED | MF_BYCOMMAND);
}

void RestoreBoard(void) { // restore for undo
	int i, j;
	// copy the board
	for (i = 0; i < BOARD_SIZE; i++) {
		for (j = 0; j < BOARD_SIZE; j++) {
			p[i][j] = copy[i][j];
		}
	}
	pass = copy_pass;
	mk = copy_mk;
	uk = copy_uk;
	// copy status string
	for (i = 0; i < STATUS_LEN; i++) {
		szCurrentText[i] = szCopyCurrentText[i];
	}
	lastI = lastJ = -1; // to fool the drawing of the last stone
	// disable (gray) the Undo command
	EnableMenuItem(myMenu, IDM_EDIT_UNDO, MF_GRAYED | MF_BYCOMMAND);
}

void ComputerMove(void) { // generate computer move
	if (play == PLAYING)	{
	    genmove(&lastI, &lastJ);	// computer move 
	    if (lastI >= 0)			// not pass 
		{
			p[lastI][lastJ] = mymove;
			examboard(umove);   // remove human's dead stones
			pass = 0; // clear passes
			play = (pass>1) ? END_GAME : PLAYING;
			// generate status string
			wsprintf(szCurrentText, szFormatNorm, (CHAR)(lastI+'A'), BOARD_SIZE-lastJ,
						szCPUCaptured, uk, szHumanCaptured, mk);
		} else {
			// after pass++ from genmove
			play = (pass>1)? END_GAME : PLAYING;
			// generate status string
			wsprintf(szCurrentText, szFormatPass, szPass,
						szCPUCaptured, uk, szHumanCaptured, mk);
		} 
		if (play == END_GAME) {
			// temporarily disable Pass on Edit menu
			EnableMenuItem(myMenu, IDM_EDIT_PASS, MF_GRAYED | MF_BYCOMMAND);
			DialogBox(hInst, (LPCTSTR)IDD_GAMEOVER, hWnd, (DLGPROC)GameOverBox);
		} else {
			// restore the "Pass" item on the Edit menu
			EnableMenuItem(myMenu, IDM_EDIT_PASS, MF_ENABLED | MF_BYCOMMAND);
		}
	}
}

void SetupGo(void) { // set up variables etc at the beginning
	half_cell = CELL_SIZE/2;
	cell_plus = CELL_SIZE+1;
	half_stone = STONE_SIZE/2;
	// Initialize brushes etc
	bbrush = GetStockObject(BLACK_BRUSH);
	wbrush = GetStockObject(WHITE_BRUSH);
	gbrush = GetStockObject(LTGRAY_BRUSH);
	cbrush = CreateSolidBrush(rgbBoard);
	redPen = CreatePen(PS_SOLID, 2, rgbCrimson);
	// Initialize Go variables
	play = PLAYING;
	pass = 0;
	mik = -1; mjk = -1;
	uik = -1; ujk = -1;
	mk = uk = 0;
	utot = mtot = 0;
	next = LOWORD(GetTickCount()); // set up random seed
	ClearBoard(); // clear the main board
	// clear the status string
	wsprintf(szCurrentText, szFormatA, szWelcome);
	sethand(0); // what handicap?
	if (debug)
		sethand(17); // to speed up the game during debug
	mymove = cpu_color;
	umove = human_color;
	endq = 0;
	queinit = 0;
	size = 0;
	lastI=lastJ=lastX=lastY = -1;
}

void CountFinalScore(void) { 
	// Uses Matthias von Davier's strategy
	// used in his Go for Palm Pilot.
	// Seems a bit fishy, but for now it'll do.
	int i,j;
	/* set empty spaces to side they belong to */
	for (i = 0; i < BOARD_SIZE; i++) {
		for (j = 0; j < BOARD_SIZE; j++) {
			if (p[i][j] == EMPTY) {
				p[i][j] = findcolor(i, j);
			}
		}
	}
	/* count total */
	mtot = 0;
	utot = 0;
	for (i = 0; i < BOARD_SIZE; i++) {
		for (j = 0; j < BOARD_SIZE; j++) {
			if (p[i][j] == mymove) {
				++mtot;
			} else {
				if (p[i][j] == umove) {
					++utot;
				}
			}
		}
	}
	// AND THE WINNER IS...
	if (utot > mtot) {
		// the human won
		wsprintf(szCurrentText, szFormatPass, szCongrats, 
					szYourScore, utot, szMyScore, mtot);
	} else {
		// the pocketPC won
		wsprintf(szCurrentText, szFormatPass, szIWin, 
					szMyScore, mtot, szYourScore, utot);
	}
	// disable (gray) the Undo command
	EnableMenuItem(myMenu, IDM_EDIT_UNDO, MF_GRAYED | MF_BYCOMMAND);
}

typedef LPWSTR FOOSTR;

int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					FOOSTR    lpCmdLine,
					int       nCmdShow)
{
	MSG msg;
	HACCEL hAccelTable;

	SetupGo(); // all initial setups

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}
	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_HELLOWORLD);
	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return msg.wParam;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    It is important to call this function so that the application 
//    will get 'well formed' small icons associated with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS	wc;

    wc.style			= CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc		= (WNDPROC) WndProc;
    wc.cbClsExtra		= 0;
    wc.cbWndExtra		= 0;
    wc.hInstance		= hInstance;
    wc.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_HELLOWORLD));
    wc.hCursor			= 0;
    wc.hbrBackground	= (HBRUSH) GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName		= 0;
    wc.lpszClassName	= szWindowClass;

	return RegisterClass(&wc);
}

//
//  FUNCTION: InitInstance(HANDLE, int)
//
//  PURPOSE: Saves instance handle and creates main window
//
//  COMMENTS:
//
//    In this function, we save the instance handle in a global variable and
//    create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	hWnd = NULL;
	TCHAR	szTitle[MAX_LOADSTRING];			// The title bar text
	TCHAR	szWindowClass[MAX_LOADSTRING];		// The window class name

	hInst = hInstance;		// Store instance handle in our global variable
	// Initialize global strings
	LoadString(hInstance, IDC_HELLOWORLD, szWindowClass, MAX_LOADSTRING);
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);

	// If it is already running, then focus on the window
	hWnd = FindWindow(szWindowClass, szTitle);	
	if (hWnd) 
	{
		SetForegroundWindow ((HWND) (((DWORD)hWnd) | 0x01));    
		return 0;
	} 

	MyRegisterClass(hInstance, szWindowClass);
	
	RECT	rect;
	GetClientRect(hWnd, &rect);
	
	hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);
	if (!hWnd)
	{	
		return FALSE;
	}
	//When the main window is created using CW_USEDEFAULT the height of the menubar (if one
	// is created is not taken into account). So we resize the window after creating it
	// if a menubar is present
	{
		RECT rc;
		GetWindowRect(hWnd, &rc);
		//rc.bottom -= MENU_HEIGHT;
		if (hwndCB)
			MoveWindow(hWnd, rc.left, rc.top, rc.right, rc.bottom, FALSE);
	}


	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	//TCHAR szHello[MAX_LOADSTRING];
	RECT rt;

	// ===========================================
	//			MESSAGE PROCESSING LOOP
	// ===========================================

	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_EDIT_UNDO: // to be expanded in a later version
					RestoreBoard(); // undo from backup
					InvalidateRect(hWnd, NULL, TRUE); // refresh
					break;
				case IDM_HELP_HELP:
					// pop up help box
					DialogBox(hInst, (LPCTSTR)IDD_HELP, hWnd, (DLGPROC)HelpBox);
					break;
				case IDM_EDIT_PASS:
					if (play == FILL_NEUTRAL) {
						play = END_GAME;
						// disable Pass on Edit menu
						EnableMenuItem(myMenu, IDM_EDIT_PASS, MF_GRAYED | MF_BYCOMMAND);
						// and count the score!!!
						CountFinalScore();
						InvalidateRect(hWnd, NULL, TRUE); // refresh
					}
					if (play == REMOVE_DEAD) {
						// phase transition to filling neutral spaces
						play = FILL_NEUTRAL;
						fill_color = human_color; // set initial fill color
						// generate new status string
						wsprintf(szCurrentText, szFormatA, szFill);
						InvalidateRect(hWnd, NULL, TRUE); // refresh
					}
					if (play == PLAYING) {
						pass++;
						play = (pass>1)? END_GAME : PLAYING;
						lastI = lastJ = -1;
						// generate status text
						wsprintf(szCurrentText, szFormatPass, szPass,
								szCPUCaptured, uk, szHumanCaptured, mk);
						// temporarily disable Pass on Edit menu
						EnableMenuItem(myMenu, IDM_EDIT_PASS, MF_GRAYED | MF_BYCOMMAND);
						if (play == END_GAME) {
							DialogBox(hInst, (LPCTSTR)IDD_GAMEOVER, hWnd, (DLGPROC)GameOverBox);
						} else {
							ComputerMove();
							InvalidateRect(hWnd, NULL, TRUE); // refresh
						}
					}
					break;
				case IDM_HELP_ABOUT:
					// pop up dialog box
					DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				    break;
				case IDM_FILE_NEW:
					// pop up dialog box
					DialogBox(hInst, (LPCTSTR)IDD_NEWGAME, hWnd, (DLGPROC)NewBox);
					break;
				case IDM_FILE_EXIT:
					// exit command selected
					SendMessage(hWnd, WM_ACTIVATE, MAKEWPARAM(WA_INACTIVE, 0), (LPARAM)hWnd);
					SendMessage(hWnd, WM_CLOSE, 0, 0);
					break;
				case IDOK:
					SendMessage(hWnd, WM_ACTIVATE, MAKEWPARAM(WA_INACTIVE, 0), (LPARAM)hWnd);
					SendMessage(hWnd, WM_CLOSE, 0, 0);
					break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		
		// Pen control
		case WM_LBUTTONDOWN:
			lastX = LOWORD(lParam);
			lastY = HIWORD(lParam);
			if (ScreenToBoard(lastX, lastY, &lastI, &lastJ)) {
				if ((play == PLAYING) && ValidMove(lastI, lastJ)) {
					BackupBoard(); // back up before we do sth stupid :)
					p[lastI][lastJ] = human_color; // make move
					pass = 0; // clear passes
					examboard(mymove);	 // remove CPU dead pieces
					// generate status text
					wsprintf(szCurrentText, szFormatNorm, (CHAR)(lastI+'A'), BOARD_SIZE-lastJ,
						szCPUCaptured, uk, szHumanCaptured, mk);
					ComputerMove();
					InvalidateRect(hWnd, NULL, TRUE);
				}
				if (play == REMOVE_DEAD) {
					// if removing dead stones, remove piece and refresh window
					p[lastI][lastJ] = EMPTY;
					InvalidateRect(hWnd, NULL, TRUE);
				}
				if (play == FILL_NEUTRAL) {
					// fill neutral in an alternating manner (black/white)
					if (p[lastI][lastJ] == EMPTY) {
						p[lastI][lastJ] = fill_color;
						if (fill_color == BLACK)
							fill_color = WHITE;
						else
							fill_color = BLACK;
						InvalidateRect(hWnd, NULL, TRUE);
					}
				}
			} else {
				// indicate no successful move; to be used by UNDO
				lastX = lastY = lastI = lastJ = -1;
			}
			break;		
		case WM_CREATE:
			hwndCB = CreateRpCommandBar(hWnd);
			myMenu = GetSubMenu((HMENU)CommandBar_GetMenu(hwndCB,0),1);
			// disable (gray) the Undo command
			// it is meaningless at the beginning of the game
			EnableMenuItem(myMenu, IDM_EDIT_UNDO, MF_GRAYED | MF_BYCOMMAND);
			break;
		case WM_PAINT:
			int i,j;
			hdc = BeginPaint(hWnd, &ps);
			GetClientRect(hWnd, &rt); // gets the rect size from the device
			rt.bottom = 255; // set the bottom border by hand
			// write status text
			DrawText(hdc, szCurrentText, _tcslen(szCurrentText), &rt,
				DT_BOTTOM | DT_CENTER);
			// draw lines on the Go board
			oldBrush = SelectObject(hdc, cbrush);
			for (i = LEFT_EDGE; i < RIGHT_EDGE; i += CELL_SIZE) {
				for (j = TOP_EDGE; j < BOTTOM_EDGE; j += CELL_SIZE) {
					Rectangle(hdc, i, j, i+cell_plus, j+cell_plus);
				}
			}
			// draw handicap dots (HARDWIRED coords!!!)
			oldBrush = SelectObject(hdc, bbrush);
			Ellipse(hdc, 46, 46, 51, 51);
			Ellipse(hdc, 46, 118, 51, 123);
			Ellipse(hdc, 46, 190, 51, 195);
			Ellipse(hdc, 118, 46, 123, 51);
			Ellipse(hdc, 118, 118, 123, 123);
			Ellipse(hdc, 118, 190, 123, 195);
			Ellipse(hdc, 190, 46, 195, 51);
			Ellipse(hdc, 190, 118, 195, 123);
			Ellipse(hdc, 190, 190, 195, 195);
			// draw Go stones
			for (i = 0; i < BOARD_SIZE; i++) {
				for (j = 0; j < BOARD_SIZE; j++) {
					if (p[i][j] != EMPTY) {
						// if board position not empty
						// select right color for brush
						if (p[i][j] == BLACK) {
							oldBrush = SelectObject(hdc, bbrush);
						} else {
							oldBrush = SelectObject(hdc, wbrush);
						}
						// and draw the stone
						Ellipse(hdc, LEFT_EDGE+CELL_SIZE*i-half_stone, TOP_EDGE+CELL_SIZE*j-half_stone, 
									LEFT_EDGE+CELL_SIZE*i+half_stone, TOP_EDGE+CELL_SIZE*j+half_stone);
					}
				}
			}
			// draw last stone differently, so human player can see it better
			if ((play == PLAYING) && (lastI >= 0)) {
				// set up colors
				oldPen = (HPEN)SelectObject(hdc, redPen);
				if (p[lastI][lastJ] == BLACK) {
					oldBrush = SelectObject(hdc, bbrush);
				} else {
					oldBrush = SelectObject(hdc, wbrush);
				}
				// draw stone
				Ellipse(hdc, LEFT_EDGE+CELL_SIZE*lastI-half_stone, TOP_EDGE+CELL_SIZE*lastJ-half_stone, 
							LEFT_EDGE+CELL_SIZE*lastI+half_stone, TOP_EDGE+CELL_SIZE*lastJ+half_stone);
				// restore black pen
				SelectObject(hdc, oldPen);
			}
			EndPaint(hWnd, &ps);
			break; 
		case WM_DESTROY:
			CommandBar_Destroy(hwndCB);
			PostQuitMessage(0);
			break;
		case WM_SETTINGCHANGE:
     		break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

HWND CreateRpCommandBar(HWND hwnd)
{
	HWND hwndCB;
    hwndCB = CommandBar_Create(hInst,hwnd,1);
	CommandBar_InsertMenubar(hwndCB,hInst,IDM_MENU,0);
	return hwndCB;
}

// Mesage handler for the About box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{

	switch (message)
	{
		case WM_INITDIALOG:
			// Create a Done button and size it.  
			return TRUE; 

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK) {
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}

// Mesage handler for the Help box.
LRESULT CALLBACK HelpBox(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{

	switch (message)
	{
		case WM_INITDIALOG:
			return TRUE; 

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK) {
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}

// Mesage handler for the Game Over box.
LRESULT CALLBACK GameOverBox(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{

	switch (message)
	{
		case WM_INITDIALOG:
			// Create a Done button and size it.  
			return TRUE; 

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK) {
				// pop up explanation box
				DialogBox(hInst, (LPCTSTR)IDD_EXPLAIN, hWnd, (DLGPROC)ExplainBox);
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			} else
			if (LOWORD(wParam) == IDCANCEL) {
				InvalidateRect(hWnd, NULL, TRUE); // last refresh
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}

// Mesage handler for the Explain box about scoring at the end of the game
LRESULT CALLBACK ExplainBox(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{

	switch (message)
	{
		case WM_INITDIALOG:
			// Create a Done button and size it.  
			// start REMOVE_DEAD mode
			play = REMOVE_DEAD;
			// restore the "Pass" item on the Edit menu
			EnableMenuItem(myMenu, IDM_EDIT_PASS, MF_ENABLED | MF_BYCOMMAND);
			// change state message
			wsprintf(szCurrentText, szFormatA, szRemove);
			//InvalidateRect(hWnd, NULL, TRUE); // last refresh
			return TRUE; 

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK) {
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}

// Mesage handler for the New Game box.
LRESULT CALLBACK NewBox(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int i;
	TCHAR	szNumber[10];		// For the items on the list
	HWND	hwndHandListCtrl;	// Window handle to the handicap list box
	HWND	hwndBlackButton;	// Window handle to the black radio button box
	int		iCurrItem = -1;		// Current item

	switch (message)
	{
		case WM_INITDIALOG:
			// Create a Done button and size it.  
			EnableMenuItem(myMenu, IDM_EDIT_UNDO, MF_GRAYED | MF_BYCOMMAND);
			// -----------------------------
			hwndHandListCtrl = GetDlgItem (hDlg, IDC_HANDICAP);
			hwndBlackButton = GetDlgItem (hDlg, IDC_BLACK);
			SendMessage (hwndBlackButton, BM_SETCHECK, BST_CHECKED, 0); // check button
			for (i = 0; i < 10; i++) {
				// place list items
				wsprintf(szNumber, szFormatB, i);
				// Add the number to the list control.
				iCurrItem = SendMessage (hwndHandListCtrl, LB_ADDSTRING, 0, 
									(LPARAM)(LPCTSTR) szNumber);

				// Set a 32-bit value, (LPARAM) i, that is associated
				// with the newly added item in the list control.
				SendMessage (hwndHandListCtrl, LB_SETITEMDATA,      
									(WPARAM) iCurrItem, (LPARAM) i);  
			}
			// final item:
			// place list items
			wsprintf(szNumber, szFormatA, TEXT("extra!"));
			// Add the number to the list control.
			iCurrItem = SendMessage (hwndHandListCtrl, LB_ADDSTRING, 0, 
									(LPARAM)(LPCTSTR) szNumber);

			// Set a 32-bit value, (LPARAM) i, that is associated
			// with the newly added item in the list control.
			SendMessage (hwndHandListCtrl, LB_SETITEMDATA,      
									(WPARAM) iCurrItem, (LPARAM) 17); 
			// Select the first number in the list control.
			SendMessage (hwndHandListCtrl, LB_SETCURSEL, 0, 0);
			// -----------------------------
			return TRUE; 

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK) {
				// see what is selected and make new game
				hwndHandListCtrl = GetDlgItem (hDlg, IDC_HANDICAP);
				hwndBlackButton = GetDlgItem (hDlg, IDC_BLACK);
				// ask button for its state
				if (BST_CHECKED == SendMessage(hwndBlackButton, BM_GETCHECK, 0, 0)) {
					human_color = BLACK;
					cpu_color = WHITE;
				} else {
					human_color = WHITE;
					cpu_color = BLACK;
				}
				// set up params
				SetupGo();
				// ask list box about handicap
				iCurrItem = SendMessage (hwndHandListCtrl, LB_GETCURSEL, 0, 0);
				if (iCurrItem < 0 || iCurrItem > 17) 
					iCurrItem = 0; // sanity check
				if (iCurrItem > 9)
					iCurrItem = 17; // last extra item
				// set handicap appropriately
				sethand(iCurrItem);
				// make computer move if CPU is black
				if (cpu_color == BLACK)
					ComputerMove();
				// clear the status string
				wsprintf(szCurrentText, szFormatA, szWelcome);
				// refresh main window
				InvalidateRect(hWnd, NULL, TRUE);
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			} else
			if (LOWORD(wParam) == IDCANCEL) {
				// just exit without any changes
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}

// =================================================================
// =================================================================
/*
 #####  #     # #     #          #####                     #             #####
#     # ##    # #     #         #     #   ####            ##            #     #
#       # #   # #     #         #        #    #          # #                  #
#  #### #  #  # #     #         #  ####  #    #            #             #####
#     # #   # # #     #         #     #  #    #            #      ###   #
#     # #    ## #     #         #     #  #    #            #      ###   #
 #####  #     #  #####           #####    ####           #####    ###   #######

writen by Man Li, w/ minor modifications by Ivan Davtchev
*/
// =================================================================
// =================================================================

void initmark(void)
/* initialize all marking with zero */
{
int i, j;

  for (i = 0; i < 19; i++)
    for (j = 0; j < 19; j++)
      ma[i][j] = 0;
}  /* end initmark */

void count(int i,     /* row number 0 to 18 */
           int j,     /* column number 0 to 18 */
           int color) /* BLACK or WHITE */
/* count liberty of color piece at location i, j
   and return value in lib */
{
/* set current piece as marked */
 ml[i][j] = EMPTY;

/* check North neighbor */
 if (i != EMPTY)
   {
    if ((p[i - 1][j] == EMPTY) && ml[i - 1][j])
      {
       ++lib;
       ml[i - 1][j] = EMPTY;
     }
    else
       if ((p[i - 1][j] == color) && ml[i - 1][j])
	  count(i - 1, j, color);
  }
/* check South neighbor */
 if (i != 18)
   {
    if ((p[i + 1][j] == EMPTY) && ml[i + 1][j])
      {
       ++lib;
       ml[i + 1][j] = EMPTY;
     }
    else
       if ((p[i + 1][j] == color) && ml[i + 1][j])
	  count(i + 1, j, color);
  }
/* check West neighbor */
 if (j != EMPTY)
   {
    if ((p[i][j - 1] == EMPTY) && ml[i][j - 1])
      {
       ++lib;
       ml[i][j - 1] = EMPTY;
     }
    else
       if ((p[i][j - 1] == color) && ml[i][j - 1])
	  count(i, j - 1, color);
  }
/* check East neighbor */
 if (j != 18)
   {
    if ((p[i][j + 1] == EMPTY) && ml[i][j + 1])
      {
       ++lib;
       ml[i][j + 1] = EMPTY;
     }
    else
       if ((p[i][j + 1] == color) && ml[i][j + 1])
	  count(i, j + 1, color);
  }
}  /* end count */

void countlib(int m,     /* row number 0 to 18 */
              int n,     /* column number 0 to 18 */
              int color) /* BLACK or WHITE */
/* count liberty of color piece at m, n */
{
 int i, j;

/* set all piece as unmarked */
 for (i = 0; i < 19; i++)
   for (j = 0; j < 19; j++)
     ml[i][j] = 1;

/* count liberty of current piece */
 count(m, n, color);
}  /* end countlib */

void node2ij(int node,
             int *i,
             int *j)
/* Converts a node number back to an i,j pair. */
{
   *i = node/BOARD_SIZE;
   *j = node%BOARD_SIZE;
}

int node(int i,
         int j)
{
  return i*BOARD_SIZE+j;
}

void createlist(int color,
                int movelist[][5])
/* Create an adjacency list, movelist, for a particular
   color of piece.
*/
{
  int i, j, k;

  for (i=0;i<BOARD_SIZE;i++) {
   for (j=0;j<BOARD_SIZE;j++) {
     k=0;
     if (p[i][j]==color) {
     /* check up */
       if ( i > 0 ) {
         if (p[i-1][j]==color) {
           movelist[node(i,j)][k]=node(i-1,j);
           k++;
         }
       }
       /* check right */ 
       if ( j < ( BOARD_SIZE -1 ) ) { 
         if ( p[i][j+1] == color ) {
           movelist[node(i,j)][k]=node(i,j+1);
           k++;
         }
       }
       /* check down */
       if ( i < ( BOARD_SIZE - 1) ) {
         if ( p[i+1][j] == color ) {
           movelist[node(i,j)][k]=node(i+1,j);
           k++;
         }
       }
       /* check left */
       if ( j > 0 ) {
         if ( p[i][j-1]==color ) {
           movelist[node(i,j)][k]=node(i,j-1);
           k++;
         }
       }
     } /* end if for color */
     /* Mark end of adjacency list for this node. */
     movelist[node(i,j)][k]=ENDLIST;
   } /* End j loop */
  } /* End i loop */
}

void enqueue(int *v)
{
  if (queinit == 0)
  {
   pe = que;
   pstart = que;
  }
  *pe = *v;
  pe++;
  size++;
  if ( pe > (que + (QSIZE - 1))) pe = que;
  if (queinit == 0) queinit++;
}

void dequeue(void)
{
 pstart++;
 size--;
 if (pstart > (que + (QSIZE - 1))) pstart = que;
}

int  bfslist(int i,
             int j,
             int movelist[][5],
             int list[])
/* Using the adjacency list, movelist, for pieces of one color
   find all connected points.  
   Starting point is defined by i and j.  Output is
   the number of points found and an array of their 
   locations.
*/
{ 
  int k,u,v;
  int w=0;

  for (k=0;k<(BOARD_SIZE*BOARD_SIZE);k++) color[k]=WHITE; /* initialization */
  color[node(i,j)] = GREY;
  u=node(i,j);
  enqueue(&u);
  while (size != 0) {
    k = 0;
    u=*pstart;
    while ((v = movelist[u][k]) != ENDLIST) {    
      if (color[v] == WHITE) {
        color[v] = GREY;
        enqueue(&v);
      }
      k++;
    }
    dequeue();
    color[u]=BLACK;
    *(listpt + w) = u;
    w++;
  }
return w;
}

void eval(int color)  /* BLACK or WHITE */
/* evaluate liberty of color pieces */
 {
  int i, j;

/* find liberty of each piece */
  for (i = 0; i < 19; i++)
    for (j = 0; j < 19; j++)
      if (p[i][j] == color)
	{
	 lib = 0;
	 countlib(i, j, color);
	 l[i][j] = lib;
      }
}  /* end eval */

void examboard(int color) /* BLACK or WHITE */
/* examine pieces */
{
   int i, j, n;

/* find liberty of each piece */
   eval(color);

/* initialize piece captured */
   if (color == mymove)
     {
      mik = -1;
      mjk = -1;
    }
   else
     {
      uik = -1;
      ujk = -1;
    }
   n = 0; /* The number of captures this move for Ko purposes */

/* remove all piece of zero liberty */
   for (i = 0; i < 19; i++)
     for (j = 0; j < 19; j++)
       if ((p[i][j] == color) && (l[i][j] == 0))
	 {
	  p[i][j] = EMPTY;
/* record piece captured */
	  if (color == mymove)
	    {
	     mik = i;
	     mjk = j;
	     ++mk;
	   }
	  else
	    {
	     uik = i;
	     ujk = j;
	     ++uk;
	   }
	  ++n;  /* increment number of captures on this move */
	}
/* reset to -1 if more than one stone captured since  no Ko possible */
   if (color == mymove && n > 1)
     {
       mik = -1;   
       mjk = -1;
     }
   else if ( n > 1 )
     {
       uik = -1;
       ujk = -1;
     }
}  /* end examboard */

unsigned int findcolor(int i,   /* row number 0 to 18 */
                       int j)   /* column number 0 to 18 */
/* find color for empty piece */
{
   int k, result, color[4];

/*
 * return color if all four neighbors are the same or empty
 */

if (p[i][j] != EMPTY) return p[i][j];


/* check North neighbor */
   if (i>0) {  /* The if prevents reading off edge of board. */
     k = i;
     do --k;
     while ((p[k][j] == EMPTY) && (k > 0));
     color[0] = p[k][j];
   }
   else color[0] = p[i][j];

/* check South neighbor */
   
   if (i<18) {
     k = i;
     do ++k;
     while ((p[k][j] == EMPTY) && (k < 18));
     color[1] = p[k][j];
   }
   else color[1] = p[i][j];

/* check West neighbor */
   if (j>0) {
     k = j;
     do --k;
     while ((p[i][k] == EMPTY) && (k > 0));
     color[2] = p[i][k];
   }
   else color[2] = p[i][j];

/* check East neighbor */
   if (j<18) {
     k = j;
     do ++k;
     while ((p[i][k] == EMPTY) && (k < 18));
     color[3] = p[i][k];
   }
   else color[3] = p[i][j];

/* Any nonEMPTY color is what we want */

   for (k=0;k<4;k++) {
     if (color[k] == EMPTY) continue;
        else {
          result = color[k];
          break;
        }
   }

/* We know the right color.  Now cross check it.*/
/* If we find an error then all the dead pieces were not taken 
   from the board and we need to prompt the players to fix this. */

  for (k=0;k<4;k++) {
/* If this next test fails, results are inconsistent.  Problem. */
     if ((color[k] != EMPTY) && (color[k] != result)) return 0;
  }

/* If we get to this point everything checks out OK.  Report results. */

   return result;
}  /* end findcolor */

int findnextmove(int m,       /* current stone row number */
                 int n,       /* current stone column number */
                 int *i,      /* next move row number */
                 int *j,      /* next move column number */
                 int *val,    /* next move value */
                 int minlib)  /* current stone liberty */
/* find new move i, j from group containing m, n */
 {
  int ti, tj, tval;
  int found = 0;

  *i = -1;   *j = -1;	*val = -1;
/* mark current position */
  ma[m][n] = 1;

/* check North neighbor */
  if (m != 0)
     if (p[m - 1][n] == EMPTY)
      {
       ti = m - 1;
       tj = n;
       lib = 0;
       countlib(ti, tj, mymove);
       tval = fval(lib, minlib);
       found = 1;
      }
     else
       if ((p[m - 1][n] == mymove) && !ma[m - 1][n])
	 if (findnextmove(m - 1, n, &ti, &tj, &tval, minlib))
	    found = 1;

  if (found)
    {
     found = 0;
     if (tval > *val && fioe(ti, tj) != 1)
       {
	*val = tval;
	*i = ti;
	*j = tj;
      }
   }

/* check South neighbor */
  if (m != 18)
     if (p[m + 1][n] == EMPTY)
      {
       ti = m + 1;
       tj = n;
       lib = 0;
       countlib(ti, tj, mymove);
       tval = fval(lib, minlib);
       found = 1;
      }
     else
       if ((p[m + 1][n] == mymove) && !ma[m + 1][n])
	  if (findnextmove(m + 1, n, &ti, &tj, &tval, minlib))
	     found = 1;

  if (found)
    {
     found = 0;
     if (tval > *val && fioe(ti, tj) != 1)
       {
	*val = tval;
	*i = ti;
	*j = tj;
      }
   }

/* check West neighbor */
  if (n != 0)
     if (p[m][n - 1] == EMPTY)
      {
       ti = m;
       tj = n - 1;
       lib = 0;
       countlib(ti, tj, mymove);
       tval = fval(lib, minlib);
       found = 1;
      }
     else
       if ((p[m][n - 1] == mymove) && !ma[m][n - 1])
	  if (findnextmove(m, n - 1, &ti, &tj, &tval, minlib))
	      found = 1;

  if (found)
    {
     found = 0;
     if (tval > *val && fioe(ti, tj) != 1)
       {
	*val = tval;
	*i = ti;
	*j = tj;
      }
   }

/* check East neighbor */
  if (n != 18)
     if (p[m][n + 1] == EMPTY)
      {
       ti = m;
       tj = n + 1;
       lib = 0;
       countlib(ti, tj, mymove);
       tval = fval(lib, minlib);
       found = 1;
      }
     else
       if ((p[m][n + 1] == mymove) && !ma[m][n + 1])
	  if (findnextmove(m, n + 1, &ti, &tj, &tval, minlib))
	      found = 1;

  if (found)
    {
     found = 0;
     if (tval > *val && fioe(ti, tj) != 1)
       {
	*val = tval;
	*i = ti;
	*j = tj;
      }
   }

 if (*val > 0)	/* found next move */
    return 1;
 else	/* next move failed */
    return 0;
}  /* end findnextmove */

int fval(int newlib,   /* new liberty */
         int minlib)   /* current liberty */
/* evaluate function for new move */
{
 int k, val;

 if (newlib <= minlib)
    val = -1;
 else
   {
    k = newlib - minlib;
    val = 40 + (k - 1) * 50 / (minlib * minlib * minlib);
  }
 return val;
}  /* end fval */

int findopen(int m,      /* current row number 0 to 18 */
             int n,      /* current column number 0 to 18 */
             int i[],    /* row array for possible moves */
             int j[],    /* column array for possible moves */
             int color,  /* BLACK or WHITE */
             int minlib, /* current liberty */
             int *ct)    /* number of possible moves */
/* find all open spaces i, j from m, n */
{
/* mark this one */
 ma[m][n] = 1;

/* check North neighbor */
 if (m != 0)
   {
    if ((p[m - 1][n] == EMPTY) && (((m - 1) != mik) || (n != mjk)))
      {
       i[*ct] = m - 1;
       j[*ct] = n;
       ++*ct;
       if (*ct == minlib) return 1;
     }
    else
      if ((p[m - 1][n] == color) && !ma[m - 1][n])
	 if (findopen(m - 1, n, i, j, color, minlib, ct) && (*ct == minlib))
	    return 1;
  }

/* check South neighbor */
 if (m != 18)
   {
    if ((p[m + 1][n] == EMPTY) && (((m + 1) != mik) || (n != mjk)))
      {
       i[*ct] = m + 1;
       j[*ct] = n;
       ++*ct;
       if (*ct == minlib) return 1;
     }
    else
      if ((p[m + 1][n] == color) && !ma[m + 1][n])
	 if (findopen(m + 1, n, i, j, color, minlib, ct) && (*ct == minlib))
	    return 1;
  }

/* check West neighbor */
 if (n != 0)
   {
    if ((p[m][n - 1] == EMPTY) && ((m != mik) || ((n - 1) != mjk)))
      {
       i[*ct] = m;
       j[*ct] = n - 1;
       ++*ct;
       if (*ct == minlib) return 1;
     }
    else
      if ((p[m][n - 1] == color) && !ma[m][n - 1])
	 if (findopen(m, n - 1, i, j, color, minlib, ct) && (*ct == minlib))
	    return 1;
  }

/* check East neighbor */
 if (n != 18)
   {
    if ((p[m][n + 1] == EMPTY) && ((m != mik) || ((n + 1) != mjk)))
      {
       i[*ct] = m;
       j[*ct] = n + 1;
       ++*ct;
       if (*ct == minlib) return 1;
     }
    else
      if ((p[m][n + 1] == color) && !ma[m][n + 1])
	 if (findopen(m, n + 1, i, j, color, minlib, ct) && (*ct == minlib))
	    return 1;
  }

/* fail to find open space */
 return 0;
}  /* end findopen */

int openregion(int i1,
               int j1,
               int i2,
               int j2)
/* check if region from i1, j1 to i2, j2 is open */
{
 int minx, maxx, miny, maxy, x, y;

/* exchange upper and lower limits */

 if (i1 < i2)
   {
    miny = i1;
    maxy = i2;
  }
 else
   {
    miny = i2;
    maxy = i1;
  }

 if (j1 < j2)
   {
    minx = j1;
    maxx = j2;
  }
 else
   {
    minx = j2;
    maxx = j1;
  }

/* check for empty region */
 for (y = miny; y <= maxy; y++)
   for (x = minx; x <= maxx; x++)
     if (p[y][x] != EMPTY) return 0;
 return 1;
}  /* end openregion */

int findpatn(int *i,    /* row number of next move */
             int *j,    /* column number of next move */
             int *val)  /* value of next move */
/* find pattern to match for next move */
{
 int m, n;
 int ti, tj, tval;
 static int cnd, mtype;  /* game tree node number, move type */
/* mtype = 0, basic; 1, inverted; 2, reflected; 3, inverted & reflected */

/* open game then occupy corners */
 if (opn[4])   /* continue last move */
   {
    opn[4] = 0;  /* clear flag */
    if (opening(i, j, &cnd, mtype)) opn[4] = 1; /* more move then reset flag */
    if (p[*i][*j] == EMPTY)  /* valid move */
      {
       *val = 80;
       return 1;
     }
    else
      opn[4] = 0;
  }

 if (opn[0])   /* Northwest corner */
   {
    opn[0] = 0;  /* clear flag */
    if (openregion(0, 0, 5, 5))
      {
       cnd = 0;
       mtype = 0;
       opening(i, j, &cnd, mtype);  /* get new node for next move */
       if (opening(i, j, &cnd, mtype)) opn[4] = 1;
       *val = 80;
       return 1;
     }
 }

 if (opn[1])   /* Southwest corner */
   {
    opn[1] = 0;
    if (openregion(13, 0, 18, 5))
      {
       cnd = 0;
       mtype = 1;
       opening(i, j, &cnd, mtype);  /* get new node for next move */
       if (opening(i, j, &cnd, mtype)) opn[4] = 1;
       *val = 80;
       return 1;
     }
  }

 if (opn[2])   /* Northeast corner */
   {
    opn[2] = 0;
    if (openregion(0, 13, 5, 18))
      {
       cnd = 0;
       mtype = 2;
       opening(i, j, &cnd, mtype);  /* get new node for next move */
       if (opening(i, j, &cnd, mtype)) opn[4] = 1;
       *val = 80;
       return 1;
     }
  }

 if (opn[3])   /* Northeast corner */
   {
    opn[3] = 0;
    if (openregion(13, 13, 18, 18))
      {
       cnd = 0;
       mtype = 3;
       opening(i, j, &cnd, mtype);  /* get new node for next move */
       if (opening(i, j, &cnd, mtype)) opn[4] = 1;
       *val = 80;
       return 1;
     }
  }

/* occupy edges */
 if (opn[5])   /* North edge */
   {
    opn[5] = 0;
    if (openregion(0, 6, 4, 11))
      {
       *i = 3;
       *j = 9;
       *val = 80;
       return 1;
     }
  }

 if (opn[6])   /* South edge */
   {
    opn[6] = 0;
    if (openregion(18, 6, 14, 11))
      {
       *i = 15;
       *j = 9;
       *val = 80;
       return 1;
     }
  }

 if (opn[7])   /* West edge */
   {
    opn[7] = 0;
    if (openregion(6, 0, 11, 4))
      {
       *i = 9;
       *j = 3;
       *val = 80;
       return 1;
     }
  }

 if (opn[8])   /* East edge */
   {
    opn[8] = 0;
    if (openregion(6, 18, 11, 14))
      {
       *i = 9;
       *j = 15;
       *val = 80;
       return 1;
     }
  }

 *i = -1;
 *j = -1;
 *val = -1;

/* find local pattern */
 for (m = 0; m < 19; m++)
   for (n = 0; n < 19; n++)
     if ((p[m][n] == mymove) &&
         (matchpat(m, n, &ti, &tj, &tval) && (tval > *val)))
       {
        *val = tval;
        *i = ti;
        *j = tj;
      }
 if (*val > 0)  /* pattern found */
    return 1;
 else  /* no match found */
    return 0;
}  /* end findpatn */

int findsaver(int *i,    /* row number of next move */
              int *j,    /* column number of next move */
              int *val)  /* value of next move */
/* find move if any pieces is threaten */
{
   int m, n, minlib;
   int ti, tj, tval;

   *i = -1;   *j = -1;	 *val = -1;
   for (minlib = 1; minlib < 4; minlib++)
      {
/* count piece with minimum liberty */
       for (m = 0; m < 19; m++)
	 for (n = 0; n < 19; n++)
	   if ((p[m][n] == mymove) && (l[m][n] == minlib))
/* find move to save pieces */
	     {
	      initmark();
	      if (findnextmove(m, n, &ti, &tj, &tval, minlib) && (tval > *val))
		{
		 *val = tval;
		 *i = ti;
		 *j = tj;
	       }
	     }
     }
    if (*val > 0)   /* find move */
       return 1;
    else	    /* move not found */
       return 0;
 }  /* findsaver */

int findwinner(int *i,    /* row number of next move */
               int *j,    /* column number of next move */
               int *val)  /* value of next move */
/* find opponent piece to capture or attack */
{
 int m, n, ti[3], tj[3], tval, ct, u, v, lib1;

 *i = -1;   *j = -1;   *val = -1;

/* find opponent with liberty less than four */
 for (m = 0; m < 19; m++)
   for (n = 0; n < 19; n++)
     if ((p[m][n] == umove) && (l[m][n] < 4))
       {
	ct = 0;
	initmark();
	if (findopen(m, n, ti, tj, umove, l[m][n], &ct))
	  {
	   if (l[m][n] == 1)
	     {
	      if (*val < 120)
		{
		 *val = 120;
		 *i = ti[0];
		 *j = tj[0];
	       }
	    }
	   else
	     for (u = 0; u < (int)l[m][n]; u++)
	       for (v = 0; v < (int)l[m][n]; v++)
		  if (u != v)
		    {
		     lib = 0;
		     countlib(ti[u], tj[u], mymove);
		     if (lib > 0) /* valid move */
		       {
                        lib1 = lib;
			p[ti[u]][tj[u]] = mymove;
		    /* look ahead opponent move */
			lib = 0;
			countlib(ti[v], tj[v], umove);
			if ((lib1 == 1) && (lib > 0))
                          tval = 0;
                        else
                          tval = 120 - 20 * lib;
			if (*val < tval)
			  {
			   *val = tval;
			   *i = ti[u];
			   *j = tj[u];
			 }
			p[ti[u]][tj[u]] = EMPTY;
		      }
		   }
	 }
      }
 if (*val > 0)	/* find move */
    return 1;
 else  /* fail to find winner */
    return 0;
}  /* end findwinner */

int fioe(int i,   /* stone row number 0 to 18 */
         int j)   /* stone column number 0 to 18 */
{
/* check top edge */
 if (i == 0)
   {
    if ((j == 0) && ((p[1][0] == mymove) && (p[0][1] == mymove))) return 1;
    if ((j == 18) && ((p[1][18] == mymove) && (p[0][17] == mymove))) return 1;
    if ((p[1][j] == mymove) &&
	((p[0][j - 1] == mymove) && (p[0][j + 1] == mymove))) return 1;
    else
       return 0;
  }
/* check bottom edge */
 if (i == 18)
   {
    if ((j == 0) && ((p[17][0] == mymove) && (p[18][1] == mymove))) return 1;
    if ((j == 18) && ((p[17][18] == mymove) && (p[18][17] == mymove))) return 1;
    if ((p[17][j] == mymove) &&
	((p[18][j - 1] == mymove) && (p[18][j + 1] == mymove)))
       return 1;
    else
       return 0;
  }
/* check left edge */
 if (j == 0)
    if ((p[i][1] == mymove) &&
	((p[i - 1] [0] == mymove) && (p[i + 1][0] == mymove)))
       return 1;
    else
       return 0;
/* check right edge */
 if (j == 18)
    if ((p[i][17] == mymove) &&
	((p[i - 1] [18] == mymove) && (p[i + 1][18] == mymove)))
       return 1;
    else
       return 0;
/* check center pieces */
 if (((p[i][j - 1] == mymove) && (p[i][j + 1] == mymove)) &&
     ((p[i - 1][j] == mymove) && (p[i + 1][j] == mymove)))
    return 1;
 else
    return 0;
}  /* fioe */

void genmove(int *i,
             int *j)
/* generate computer move */
{
   int ti, tj, tval;
   char a;
   int ii, val;
   int trial = 0;   /* number of trial */

/* initialize move and value */
   *i = -1;  *j = -1;  val = -1;

/* re-evaluate liberty of opponent pieces */
   eval(umove);

/* find opponent piece to capture or attack */
   if (findwinner(&ti, &tj, &tval))
       if (tval > val)
	 {
	  val = tval;
	  *i = ti;
	  *j = tj;
	}

/* save any piece if threaten */
   if (findsaver(&ti, &tj, &tval))
       if (tval > val)
	 {
	  val = tval;
	  *i = ti;
	  *j = tj;
	}

/* try match local play pattern for new move */
   if (findpatn(&ti, &tj, &tval))
       if (tval > val)
	 {
	  val = tval;
	  *i = ti;
	  *j = tj;
	}

/* no urgent move then do random move */
   if (val < 0)
       do {
	   *i = myrandom(19);

/* avoid low line  and center region */
	   if ((*i < 2) || (*i > 16) || ((*i > 5) && (*i < 13)))
	     {
	      *i = myrandom(19);
	      if ((*i < 2) || (*i > 16))
                *i = myrandom(19);
	    }

           *j = myrandom(19);

/* avoid low line and center region */
	   if ((*j < 2) || (*j > 16) || ((*j > 5) && (*j < 13)))
	     {
              *j = myrandom(19);

	      if ((*j < 2) || (*j > 16))
                *j = myrandom(19);

	    }
	    lib = 0;
	    countlib(*i, *j, mymove);
       }
/* avoid illegal move, liberty one or suicide, fill in own eye */
       while ((++trial < MAXTRY)
	      && ((p[*i][*j] != EMPTY) || (lib < 2) || fioe(*i, *j)));

   if (trial >= MAXTRY)  /* computer pass */
     {
      pass++;
      //printf("I pass.\n");
      *i = -1;
    }
   else   /* find valid move */
     {
      pass = 0;      
      //printf("my move: ");
      if (*j < 8)
	 a = *j + 65;
      else
	 a = *j + 66;
      //printf("%c", a);
      ii = 19 - *i;
      if (ii < 10)
	 /*printf("%1d\n", ii)*/;
      else
	 /*printf("%2d\n", ii)*/;
    }
}  /* end genmove */

int matchpat(int m,     /* row origin */
             int n,     /* column origin */
             int *i,    /* row number of next move */
             int *j,    /* column number of next move */
             int *val)  /* next move value */
/* match pattern and get next move */
{
/* transformation matrice */
 static int trf [8][2][2] = {
   {{1, 0}, {0, 1}},   /* linear transfomation matrix */
   {{1, 0}, {0, -1}},  /* invert */
   {{0, 1}, {-1, 0}},  /* rotate 90 */
   {{0, -1}, {-1, 0}}, /* rotate 90 and invert */
   {{-1, 0}, {0, 1}},  /* flip left */
   {{-1, 0}, {0, -1}}, /* flip left and invert */
   {{0, 1}, {1, 0}},   /* rotate 90 and flip left */
   {{0, -1}, {1, 0}}   /* rotate 90, flip left and invert */
 };
 int k, my, nx, ll, r, cont;
 int ti, tj, tval;

 *i = -1;   *j = -1;   *val = -1;
 for (r = 0; r < PATNO; r++)
/* try each pattern */
    for (ll = 0; ll < pat[r].trfno; ll++)
/* try each orientation transformation */
      {
       k = 0;  cont = 1;
       while ((k != pat[r].patlen) && cont)
/* match each point */
	 {
/* transform pattern real coordinate */
	  nx = n + trf[ll][0][0] * pat[r].patn[k].x
		 + trf[ll][0][1] * pat[r].patn[k].y;
	  my = m + trf[ll][1][0] * pat[r].patn[k].x
		 + trf[ll][1][1] * pat[r].patn[k].y;

/* outside the board */
	  if ((my < 0) || ( my > 18) || (nx < 0) || (nx > 18))
	    {
	     cont = 0;
	     break;
	   }
	  switch (pat[r].patn[k].att) {
	  case 0 : if (p[my][nx] == EMPTY)	/* open */
		      break;
		   else
		     {
		      cont = 0;
		      break;
		    }
	  case 1 : if (p[my][nx] == umove)  /* your piece */
		      break;
		   else
		     {
		      cont = 0;
		      break;
		    }
	  case 2 : if (p[my][nx] == mymove)  /* my piece */
		      break;
		   else
		     {
		      cont = 0;
		      break;
		    }
	  case 3 : if (p[my][nx] == EMPTY)	/* open for new move */
		    {
		     lib = 0;
		     countlib(my, nx, mymove);	/* check liberty */
		     if (lib > 1)  /* move o.k. */
		       {
			ti = my;
			tj = nx;
			break;
		       }
		     else
		       {
			cont = 0;
			break;
		      }
		     }
		   else
		     {
		      cont = 0;
		      break;
		    }
	  case 4 : if ((p[my][nx] == EMPTY)  /* open on edge */
		       && ((my == 0) || (my == 18) || (nx == 0) || (nx == 18)))
		      break;
		   else
		     {
		      cont = 0;
		      break;
		    }
	  case 5 : if ((p[my][nx] == umove)  /* your piece on edge */
		       && ((my == 0) || (my == 18) || (nx == 0) || (nx == 18)))
		      break;
		   else
		     {
		      cont = 0;
		      break;
		    }
	  case 6 : if ((p[my][nx] == mymove)  /* my piece on edge */
		       && ((my == 0) || (my == 18) || (nx == 0) || (nx == 18)))
		      break;
		   else
		     {
		      cont = 0;
		      break;
		    }
		 }
	  ++k;
	 }
	 if (cont)   /* match pattern */
	   {
	    tval = pat[r].patwt;
	    if ((r >= 8) && (r <= 13))	/* patterns for expand region */
	      {
	       if (line(ti) > 7)  /* penalty on line 1, 2 */
		  tval--;
	       else
		  if ((line(ti) == 6) || (line(ti) == 7))
		     tval++;	/* reward on line 3, 4 */

	       if (line(tj) > 7)  /* penalty on line 1, 2 */
		  tval--;
	       else
		  if ((line(tj) == 6) || (line(tj) == 7))
		     tval++;	/* reward on line 3, 4 */
	     }
	    if (tval > *val)
	      {
	       *val = tval;
	       *i = ti;
	       *j = tj;
	     }
	  }
      }
 if (*val > 0)	/* pattern matched */
    return 1;
 else  /* match failed */
    return 0;
}  /* end matchpat */

int opening(int *i,
            int *j,
            int *cnd,
            int type)
/* get move for opening from game tree */
{
 struct tnode {
   int i, j, ndct, next[8];
  };

 static struct tnode tree[] = {
  {-1, -1, 8, { 1, 2, 3, 4, 5, 6, 7, 20}},	/* 0 */
  {2, 3, 2, { 8, 9}},
  {2, 4, 1, {10}},
  {3, 2, 2, {11, 12}},
  {3, 3, 6, {14, 15, 16, 17, 18, 19}},
  {3, 4, 1, {10}},  /* 5 */
  {4, 2, 1, {13}},
  {4, 3, 1, {13}},
  {4, 2, 0},
  {4, 3, 0},
  {3, 2, 0},  /* 10 */
  {2, 4, 0},
  {3, 4, 0},
  {2, 3, 0},
  {2, 5, 1, {10}},
  {2, 6, 1, {10}},  /* 15 */
  {3, 5, 1, {10}},
  {5, 2, 1, {13}},
  {5, 3, 1, {13}},
  {6, 2, 1, {13}},
  {2, 2, 0}  /* 20 */
};
int m;

/* get i, j */
 if ((type == 1) || (type == 3))
    *i = 18 - tree[*cnd].i;   /* inverted */
 else
    *i = tree[*cnd].i;
 if ((type == 2) || (type == 3))
    *j = 18 - tree[*cnd].j;   /* reflected */
 else
    *j = tree[*cnd].j;
 if (tree[*cnd].ndct)  /* more move */
   {
    m = rand() % tree[*cnd].ndct;  /* select move */
    *cnd = tree[*cnd].next[m];	/* new	current node */
    return 1;
  }
 else
    return 0;
}  /* end opening */

void sethand(int i)
/* set up handicap pieces */
{
 if (i > 0)
   {
    p[3][3] = BLACK;
    if (i > 1)
      {
       p[15][15] = BLACK;
       if (i > 2)
	 {
	  p[3][15] = BLACK;
	  if (i > 3)
	    {
	     p[15][3] = BLACK;
	     if (i == 5)
		p[9][9] = BLACK;
	     else
		if (i > 5)
		  {
		   p[9][15] = BLACK;
		   p[9][3] = BLACK;
		   if (i == 7)
		      p[9][9] = BLACK;
		   else
		      if (i > 7)
			{
			 p[15][9] = BLACK;
			 p[3][9] = BLACK;
			 if (i > 8)
			 p[9][9] = BLACK;
 			 if (i > 9)
 			   {p[2][2] = BLACK;
 			    if (i > 10)
 			      {p[16][16] = BLACK;
 			       if (i > 11)
 				 {p[2][16] = BLACK;
 				  if (i > 12)
 				    {p[16][2] = BLACK;
 				     if (i > 13)
 				       {p[6][6] = BLACK;
 					if (i > 14)
 					  {p[12][12] = BLACK;
 					   if (i > 15)
 					     {p[6][12] = BLACK;
 					      if (i > 16)
 						p[12][6] = BLACK;
 					    }
 					 }
 				      }
 				   }
 				}
 			     }
 			  }
		       }
		 }
	   }
	}
     }
  }
}  /* end sethand */

int suicide(int i,
            int j)
/* check for suicide move of opponent at p[i][j] */
{
 int m, n, k;

/* check liberty of new move */
 lib = 0;
 countlib(i, j, umove);
 if (lib == 0)
/* new move is suicide then check if kill my pieces and Ko possibility */
   {
/* assume alive */
    p[i][j] = umove;

/* check my pieces */
    eval(mymove);
    k = 0;

    for (m = 0; m < 19; m++)
      for (n = 0; n < 19; n++)
/* count pieces will be killed */
	if ((p[m][n] == mymove) && !l[m][n]) ++k;

    if ((k == 0) || (k == 1 && ((i == uik) && (j == ujk))))
/* either no effect on my pieces or an illegal Ko take back */
      {
       p[i][j] = EMPTY;   /* restore to open */
       return 1;
      }
    else
/* good move */
      return 0;
   }
 else
/* valid move */
   return 0;
}  /* end suicide */
